/* marker.c generated by valac 0.52.3, the Vala compiler
 * generated from marker.vala, do not modify */

/* Marker facility functions

   Copyright (c) 2004-2020 Free Software Foundation, Inc.

   This file is part of GNU Zile.

   GNU Zile is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   GNU Zile is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, see <https://www.gnu.org/licenses/>.  */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>
#include <gee.h>

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define MARKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MARKER, MarkerClass))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define IS_MARKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MARKER))
#define MARKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MARKER, MarkerClass))

typedef struct _Marker Marker;
typedef struct _MarkerClass MarkerClass;
typedef struct _MarkerPrivate MarkerPrivate;

#define TYPE_BUFFER (buffer_get_type ())
#define BUFFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BUFFER, Buffer))
#define BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BUFFER, BufferClass))
#define IS_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BUFFER))
#define IS_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BUFFER))
#define BUFFER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BUFFER, BufferClass))

typedef struct _Buffer Buffer;
typedef struct _BufferClass BufferClass;
#define _marker_unref0(var) ((var == NULL) ? NULL : (var = (marker_unref (var), NULL)))
#define _buffer_unref0(var) ((var == NULL) ? NULL : (var = (buffer_unref (var), NULL)))
typedef struct _BufferPrivate BufferPrivate;

#define TYPE_UNDO (undo_get_type ())
#define UNDO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNDO, Undo))
#define UNDO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNDO, UndoClass))
#define IS_UNDO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNDO))
#define IS_UNDO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNDO))
#define UNDO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNDO, UndoClass))

typedef struct _Undo Undo;
typedef struct _UndoClass UndoClass;

#define TYPE_VAR_ENTRY (var_entry_get_type ())
#define VAR_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VAR_ENTRY, VarEntry))
#define VAR_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VAR_ENTRY, VarEntryClass))
#define IS_VAR_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VAR_ENTRY))
#define IS_VAR_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VAR_ENTRY))
#define VAR_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VAR_ENTRY, VarEntryClass))

typedef struct _VarEntry VarEntry;
typedef struct _VarEntryClass VarEntryClass;
typedef struct _ParamSpecMarker ParamSpecMarker;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Marker {
	GTypeInstance parent_instance;
	volatile int ref_count;
	MarkerPrivate * priv;
	Buffer* bp;
};

struct _MarkerClass {
	GTypeClass parent_class;
	void (*finalize) (Marker *self);
};

struct _MarkerPrivate {
	Marker* _next;
	gsize _o;
};

struct _Buffer {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BufferPrivate * priv;
	gchar* name;
	gchar* filename;
	Buffer* next;
	gsize goalc;
	Marker* mark;
	Marker* markers;
	GList* last_undop;
	GList* next_undop;
	GHashTable* vars;
	gboolean modified;
	gboolean nosave;
	gboolean needname;
	gboolean temporary;
	gboolean readonly;
	gboolean backup;
	gboolean noundo;
	gboolean autofill;
	gboolean isearch;
	gboolean mark_active;
	gchar* dir;
};

struct _BufferClass {
	GTypeClass parent_class;
	void (*finalize) (Buffer *self);
	gsize (*get_length) (Buffer* self);
	const gchar* (*get_eol) (Buffer* self);
};

struct _ParamSpecMarker {
	GParamSpec parent_instance;
};

static gint Marker_private_offset;
static gpointer marker_parent_class = NULL;
extern Buffer* cur_bp;
extern GList* mark_ring;
GList* mark_ring = NULL;

gpointer marker_ref (gpointer instance);
void marker_unref (gpointer instance);
GParamSpec* param_spec_marker (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags);
void value_set_marker (GValue* value,
                       gpointer v_object);
void value_take_marker (GValue* value,
                        gpointer v_object);
gpointer value_get_marker (const GValue* value);
GType marker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Marker, marker_unref)
gpointer buffer_ref (gpointer instance);
void buffer_unref (gpointer instance);
GParamSpec* param_spec_buffer (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags);
void value_set_buffer (GValue* value,
                       gpointer v_object);
void value_take_buffer (GValue* value,
                        gpointer v_object);
gpointer value_get_buffer (const GValue* value);
GType buffer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Buffer, buffer_unref)
void marker_unchain (Marker* self);
gpointer undo_ref (gpointer instance);
void undo_unref (gpointer instance);
GParamSpec* param_spec_undo (const gchar* name,
                             const gchar* nick,
                             const gchar* blurb,
                             GType object_type,
                             GParamFlags flags);
void value_set_undo (GValue* value,
                     gpointer v_object);
void value_take_undo (GValue* value,
                      gpointer v_object);
gpointer value_get_undo (const GValue* value);
GType undo_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Undo, undo_unref)
gpointer var_entry_ref (gpointer instance);
void var_entry_unref (gpointer instance);
GParamSpec* param_spec_var_entry (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
void value_set_var_entry (GValue* value,
                          gpointer v_object);
void value_take_var_entry (GValue* value,
                           gpointer v_object);
gpointer value_get_var_entry (const GValue* value);
GType var_entry_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VarEntry, var_entry_unref)
Marker* marker_get_next (Marker* self);
void marker_set_next (Marker* self,
                      Marker* value);
void marker_move (Marker* self,
                  Buffer* bp,
                  gsize o);
void marker_set_o (Marker* self,
                   gsize value);
Marker* marker_copy (Marker* m);
Marker* marker_new (void);
Marker* marker_construct (GType object_type);
gsize marker_get_o (Marker* self);
Marker* marker_point (void);
gsize buffer_get_pt (Buffer* self);
static void marker_finalize (Marker * obj);
static GType marker_get_type_once (void);
void push_mark (void);
gboolean funcall (const gchar* name,
                  glong* maybe_uniarg,
                  GeeQueue* args);
void pop_mark (void);
void set_mark (void);

static inline gpointer
marker_get_instance_private (Marker* self)
{
	return G_STRUCT_MEMBER_P (self, Marker_private_offset);
}

static gpointer
_marker_ref0 (gpointer self)
{
#line 30 "src/marker.vala"
	return self ? marker_ref (self) : NULL;
#line 231 "marker.c"
}

void
marker_unchain (Marker* self)
{
	Buffer* _tmp0_;
	Marker* prev = NULL;
#line 25 "src/marker.vala"
	g_return_if_fail (self != NULL);
#line 26 "src/marker.vala"
	_tmp0_ = self->bp;
#line 26 "src/marker.vala"
	if (_tmp0_ == NULL) {
#line 27 "src/marker.vala"
		return;
#line 247 "marker.c"
	}
#line 29 "src/marker.vala"
	prev = NULL;
#line 251 "marker.c"
	{
		Marker* m = NULL;
		Buffer* _tmp1_;
		Marker* _tmp2_;
		Marker* _tmp3_;
#line 30 "src/marker.vala"
		_tmp1_ = self->bp;
#line 30 "src/marker.vala"
		_tmp2_ = _tmp1_->markers;
#line 30 "src/marker.vala"
		_tmp3_ = _marker_ref0 (_tmp2_);
#line 30 "src/marker.vala"
		m = _tmp3_;
#line 265 "marker.c"
		{
			gboolean _tmp4_ = FALSE;
#line 30 "src/marker.vala"
			_tmp4_ = TRUE;
#line 30 "src/marker.vala"
			while (TRUE) {
#line 272 "marker.c"
				Marker* _tmp8_;
				Marker* _tmp9_;
				Marker* _tmp20_;
				Marker* _tmp21_;
#line 30 "src/marker.vala"
				if (!_tmp4_) {
#line 279 "marker.c"
					Marker* _tmp5_;
					Marker* _tmp6_;
					Marker* _tmp7_;
#line 30 "src/marker.vala"
					_tmp5_ = m;
#line 30 "src/marker.vala"
					_tmp6_ = _tmp5_->priv->_next;
#line 30 "src/marker.vala"
					_tmp7_ = _marker_ref0 (_tmp6_);
#line 30 "src/marker.vala"
					_marker_unref0 (m);
#line 30 "src/marker.vala"
					m = _tmp7_;
#line 293 "marker.c"
				}
#line 30 "src/marker.vala"
				_tmp4_ = FALSE;
#line 30 "src/marker.vala"
				_tmp8_ = m;
#line 30 "src/marker.vala"
				if (!(_tmp8_ != NULL)) {
#line 30 "src/marker.vala"
					break;
#line 303 "marker.c"
				}
#line 31 "src/marker.vala"
				_tmp9_ = m;
#line 31 "src/marker.vala"
				if (_tmp9_ == self) {
#line 309 "marker.c"
					Marker* _tmp10_;
					Marker* _tmp19_;
#line 32 "src/marker.vala"
					_tmp10_ = prev;
#line 32 "src/marker.vala"
					if (_tmp10_ != NULL) {
#line 316 "marker.c"
						Marker* _tmp11_;
						Marker* _tmp12_;
						Marker* _tmp13_;
#line 33 "src/marker.vala"
						_tmp11_ = prev;
#line 33 "src/marker.vala"
						_tmp12_ = m;
#line 33 "src/marker.vala"
						_tmp13_ = _tmp12_->priv->_next;
#line 33 "src/marker.vala"
						marker_set_next (_tmp11_, _tmp13_);
#line 328 "marker.c"
					} else {
						Marker* _tmp14_;
						Buffer* _tmp15_;
						Marker* _tmp16_;
						Marker* _tmp17_;
						Marker* _tmp18_;
#line 35 "src/marker.vala"
						_tmp14_ = m;
#line 35 "src/marker.vala"
						_tmp15_ = _tmp14_->bp;
#line 35 "src/marker.vala"
						_tmp16_ = m;
#line 35 "src/marker.vala"
						_tmp17_ = _tmp16_->priv->_next;
#line 35 "src/marker.vala"
						_tmp18_ = _marker_ref0 (_tmp17_);
#line 35 "src/marker.vala"
						_marker_unref0 (_tmp15_->markers);
#line 35 "src/marker.vala"
						_tmp15_->markers = _tmp18_;
#line 349 "marker.c"
					}
#line 37 "src/marker.vala"
					_tmp19_ = m;
#line 37 "src/marker.vala"
					_buffer_unref0 (_tmp19_->bp);
#line 37 "src/marker.vala"
					_tmp19_->bp = NULL;
#line 38 "src/marker.vala"
					break;
#line 359 "marker.c"
				}
#line 40 "src/marker.vala"
				_tmp20_ = m;
#line 40 "src/marker.vala"
				_tmp21_ = _marker_ref0 (_tmp20_);
#line 40 "src/marker.vala"
				_marker_unref0 (prev);
#line 40 "src/marker.vala"
				prev = _tmp21_;
#line 369 "marker.c"
			}
		}
#line 30 "src/marker.vala"
		_marker_unref0 (m);
#line 374 "marker.c"
	}
#line 25 "src/marker.vala"
	_marker_unref0 (prev);
#line 378 "marker.c"
}

static gpointer
_buffer_ref0 (gpointer self)
{
#line 50 "src/marker.vala"
	return self ? buffer_ref (self) : NULL;
#line 386 "marker.c"
}

void
marker_move (Marker* self,
             Buffer* bp,
             gsize o)
{
	Buffer* _tmp0_;
#line 44 "src/marker.vala"
	g_return_if_fail (self != NULL);
#line 44 "src/marker.vala"
	g_return_if_fail (bp != NULL);
#line 45 "src/marker.vala"
	_tmp0_ = self->bp;
#line 45 "src/marker.vala"
	if (bp != _tmp0_) {
#line 403 "marker.c"
		Buffer* _tmp1_;
		Marker* _tmp2_;
		Marker* _tmp3_;
#line 47 "src/marker.vala"
		marker_unchain (self);
#line 50 "src/marker.vala"
		_tmp1_ = _buffer_ref0 (bp);
#line 50 "src/marker.vala"
		_buffer_unref0 (self->bp);
#line 50 "src/marker.vala"
		self->bp = _tmp1_;
#line 53 "src/marker.vala"
		_tmp2_ = bp->markers;
#line 53 "src/marker.vala"
		marker_set_next (self, _tmp2_);
#line 54 "src/marker.vala"
		_tmp3_ = _marker_ref0 (self);
#line 54 "src/marker.vala"
		_marker_unref0 (bp->markers);
#line 54 "src/marker.vala"
		bp->markers = _tmp3_;
#line 425 "marker.c"
	}
#line 58 "src/marker.vala"
	marker_set_o (self, o);
#line 429 "marker.c"
}

Marker*
marker_copy (Marker* m)
{
	Marker* marker = NULL;
	Marker* result = NULL;
#line 62 "src/marker.vala"
	marker = NULL;
#line 63 "src/marker.vala"
	if (m != NULL) {
#line 441 "marker.c"
		Marker* _tmp0_;
		Marker* _tmp1_;
		Buffer* _tmp2_;
		gsize _tmp3_;
#line 64 "src/marker.vala"
		_tmp0_ = marker_new ();
#line 64 "src/marker.vala"
		_marker_unref0 (marker);
#line 64 "src/marker.vala"
		marker = _tmp0_;
#line 65 "src/marker.vala"
		_tmp1_ = marker;
#line 65 "src/marker.vala"
		_tmp2_ = m->bp;
#line 65 "src/marker.vala"
		_tmp3_ = m->priv->_o;
#line 65 "src/marker.vala"
		marker_move (_tmp1_, _tmp2_, _tmp3_);
#line 460 "marker.c"
	}
#line 67 "src/marker.vala"
	result = marker;
#line 67 "src/marker.vala"
	return result;
#line 466 "marker.c"
}

Marker*
marker_point (void)
{
	Marker* m = NULL;
	Marker* _tmp0_;
	Buffer* _tmp1_;
	Buffer* _tmp2_;
	gsize _tmp3_;
	gsize _tmp4_;
	Marker* result = NULL;
#line 71 "src/marker.vala"
	_tmp0_ = marker_new ();
#line 71 "src/marker.vala"
	m = _tmp0_;
#line 72 "src/marker.vala"
	_tmp1_ = cur_bp;
#line 72 "src/marker.vala"
	_tmp2_ = cur_bp;
#line 72 "src/marker.vala"
	_tmp3_ = buffer_get_pt (_tmp2_);
#line 72 "src/marker.vala"
	_tmp4_ = _tmp3_;
#line 72 "src/marker.vala"
	marker_move (m, _tmp1_, _tmp4_);
#line 73 "src/marker.vala"
	result = m;
#line 73 "src/marker.vala"
	return result;
#line 497 "marker.c"
}

Marker*
marker_construct (GType object_type)
{
	Marker* self = NULL;
#line 20 "src/marker.vala"
	self = (Marker*) g_type_create_instance (object_type);
#line 20 "src/marker.vala"
	return self;
#line 508 "marker.c"
}

Marker*
marker_new (void)
{
#line 20 "src/marker.vala"
	return marker_construct (TYPE_MARKER);
#line 516 "marker.c"
}

Marker*
marker_get_next (Marker* self)
{
	Marker* result;
	Marker* _tmp0_;
#line 21 "src/marker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 21 "src/marker.vala"
	_tmp0_ = self->priv->_next;
#line 21 "src/marker.vala"
	result = _tmp0_;
#line 21 "src/marker.vala"
	return result;
#line 532 "marker.c"
}

void
marker_set_next (Marker* self,
                 Marker* value)
{
	Marker* _tmp0_;
#line 21 "src/marker.vala"
	g_return_if_fail (self != NULL);
#line 21 "src/marker.vala"
	_tmp0_ = _marker_ref0 (value);
#line 21 "src/marker.vala"
	_marker_unref0 (self->priv->_next);
#line 21 "src/marker.vala"
	self->priv->_next = _tmp0_;
#line 548 "marker.c"
}

gsize
marker_get_o (Marker* self)
{
	gsize result;
#line 22 "src/marker.vala"
	g_return_val_if_fail (self != NULL, 0UL);
#line 22 "src/marker.vala"
	result = self->priv->_o;
#line 22 "src/marker.vala"
	return result;
#line 561 "marker.c"
}

void
marker_set_o (Marker* self,
              gsize value)
{
#line 22 "src/marker.vala"
	g_return_if_fail (self != NULL);
#line 22 "src/marker.vala"
	self->priv->_o = value;
#line 572 "marker.c"
}

static void
value_marker_init (GValue* value)
{
#line 20 "src/marker.vala"
	value->data[0].v_pointer = NULL;
#line 580 "marker.c"
}

static void
value_marker_free_value (GValue* value)
{
#line 20 "src/marker.vala"
	if (value->data[0].v_pointer) {
#line 20 "src/marker.vala"
		marker_unref (value->data[0].v_pointer);
#line 590 "marker.c"
	}
}

static void
value_marker_copy_value (const GValue* src_value,
                         GValue* dest_value)
{
#line 20 "src/marker.vala"
	if (src_value->data[0].v_pointer) {
#line 20 "src/marker.vala"
		dest_value->data[0].v_pointer = marker_ref (src_value->data[0].v_pointer);
#line 602 "marker.c"
	} else {
#line 20 "src/marker.vala"
		dest_value->data[0].v_pointer = NULL;
#line 606 "marker.c"
	}
}

static gpointer
value_marker_peek_pointer (const GValue* value)
{
#line 20 "src/marker.vala"
	return value->data[0].v_pointer;
#line 615 "marker.c"
}

static gchar*
value_marker_collect_value (GValue* value,
                            guint n_collect_values,
                            GTypeCValue* collect_values,
                            guint collect_flags)
{
#line 20 "src/marker.vala"
	if (collect_values[0].v_pointer) {
#line 626 "marker.c"
		Marker * object;
		object = collect_values[0].v_pointer;
#line 20 "src/marker.vala"
		if (object->parent_instance.g_class == NULL) {
#line 20 "src/marker.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 633 "marker.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 20 "src/marker.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 637 "marker.c"
		}
#line 20 "src/marker.vala"
		value->data[0].v_pointer = marker_ref (object);
#line 641 "marker.c"
	} else {
#line 20 "src/marker.vala"
		value->data[0].v_pointer = NULL;
#line 645 "marker.c"
	}
#line 20 "src/marker.vala"
	return NULL;
#line 649 "marker.c"
}

static gchar*
value_marker_lcopy_value (const GValue* value,
                          guint n_collect_values,
                          GTypeCValue* collect_values,
                          guint collect_flags)
{
	Marker ** object_p;
	object_p = collect_values[0].v_pointer;
#line 20 "src/marker.vala"
	if (!object_p) {
#line 20 "src/marker.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 664 "marker.c"
	}
#line 20 "src/marker.vala"
	if (!value->data[0].v_pointer) {
#line 20 "src/marker.vala"
		*object_p = NULL;
#line 670 "marker.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 20 "src/marker.vala"
		*object_p = value->data[0].v_pointer;
#line 674 "marker.c"
	} else {
#line 20 "src/marker.vala"
		*object_p = marker_ref (value->data[0].v_pointer);
#line 678 "marker.c"
	}
#line 20 "src/marker.vala"
	return NULL;
#line 682 "marker.c"
}

GParamSpec*
param_spec_marker (const gchar* name,
                   const gchar* nick,
                   const gchar* blurb,
                   GType object_type,
                   GParamFlags flags)
{
	ParamSpecMarker* spec;
#line 20 "src/marker.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_MARKER), NULL);
#line 20 "src/marker.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 20 "src/marker.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 20 "src/marker.vala"
	return G_PARAM_SPEC (spec);
#line 701 "marker.c"
}

gpointer
value_get_marker (const GValue* value)
{
#line 20 "src/marker.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MARKER), NULL);
#line 20 "src/marker.vala"
	return value->data[0].v_pointer;
#line 711 "marker.c"
}

void
value_set_marker (GValue* value,
                  gpointer v_object)
{
	Marker * old;
#line 20 "src/marker.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MARKER));
#line 20 "src/marker.vala"
	old = value->data[0].v_pointer;
#line 20 "src/marker.vala"
	if (v_object) {
#line 20 "src/marker.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_MARKER));
#line 20 "src/marker.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "src/marker.vala"
		value->data[0].v_pointer = v_object;
#line 20 "src/marker.vala"
		marker_ref (value->data[0].v_pointer);
#line 733 "marker.c"
	} else {
#line 20 "src/marker.vala"
		value->data[0].v_pointer = NULL;
#line 737 "marker.c"
	}
#line 20 "src/marker.vala"
	if (old) {
#line 20 "src/marker.vala"
		marker_unref (old);
#line 743 "marker.c"
	}
}

void
value_take_marker (GValue* value,
                   gpointer v_object)
{
	Marker * old;
#line 20 "src/marker.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MARKER));
#line 20 "src/marker.vala"
	old = value->data[0].v_pointer;
#line 20 "src/marker.vala"
	if (v_object) {
#line 20 "src/marker.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_MARKER));
#line 20 "src/marker.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "src/marker.vala"
		value->data[0].v_pointer = v_object;
#line 764 "marker.c"
	} else {
#line 20 "src/marker.vala"
		value->data[0].v_pointer = NULL;
#line 768 "marker.c"
	}
#line 20 "src/marker.vala"
	if (old) {
#line 20 "src/marker.vala"
		marker_unref (old);
#line 774 "marker.c"
	}
}

static void
marker_class_init (MarkerClass * klass,
                   gpointer klass_data)
{
#line 20 "src/marker.vala"
	marker_parent_class = g_type_class_peek_parent (klass);
#line 20 "src/marker.vala"
	((MarkerClass *) klass)->finalize = marker_finalize;
#line 20 "src/marker.vala"
	g_type_class_adjust_private_offset (klass, &Marker_private_offset);
#line 788 "marker.c"
}

static void
marker_instance_init (Marker * self,
                      gpointer klass)
{
#line 20 "src/marker.vala"
	self->priv = marker_get_instance_private (self);
#line 20 "src/marker.vala"
	self->ref_count = 1;
#line 799 "marker.c"
}

static void
marker_finalize (Marker * obj)
{
	Marker * self;
#line 20 "src/marker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MARKER, Marker);
#line 20 "src/marker.vala"
	g_signal_handlers_destroy (self);
#line 21 "src/marker.vala"
	_marker_unref0 (self->priv->_next);
#line 23 "src/marker.vala"
	_buffer_unref0 (self->bp);
#line 814 "marker.c"
}

static GType
marker_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_marker_init, value_marker_free_value, value_marker_copy_value, value_marker_peek_pointer, "p", value_marker_collect_value, "p", value_marker_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (MarkerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) marker_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Marker), 0, (GInstanceInitFunc) marker_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType marker_type_id;
	marker_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Marker", &g_define_type_info, &g_define_type_fundamental_info, 0);
	Marker_private_offset = g_type_add_instance_private (marker_type_id, sizeof (MarkerPrivate));
	return marker_type_id;
}

GType
marker_get_type (void)
{
	static volatile gsize marker_type_id__volatile = 0;
	if (g_once_init_enter (&marker_type_id__volatile)) {
		GType marker_type_id;
		marker_type_id = marker_get_type_once ();
		g_once_init_leave (&marker_type_id__volatile, marker_type_id);
	}
	return marker_type_id__volatile;
}

gpointer
marker_ref (gpointer instance)
{
	Marker * self;
	self = instance;
#line 20 "src/marker.vala"
	g_atomic_int_inc (&self->ref_count);
#line 20 "src/marker.vala"
	return instance;
#line 850 "marker.c"
}

void
marker_unref (gpointer instance)
{
	Marker * self;
	self = instance;
#line 20 "src/marker.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 20 "src/marker.vala"
		MARKER_GET_CLASS (self)->finalize (self);
#line 20 "src/marker.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 864 "marker.c"
	}
}

void
push_mark (void)
{
	Buffer* _tmp0_;
	Marker* _tmp1_;
#line 86 "src/marker.vala"
	_tmp0_ = cur_bp;
#line 86 "src/marker.vala"
	_tmp1_ = _tmp0_->mark;
#line 86 "src/marker.vala"
	if (_tmp1_ != NULL) {
#line 879 "marker.c"
		Buffer* _tmp2_;
		Marker* _tmp3_;
		Marker* _tmp4_;
#line 87 "src/marker.vala"
		_tmp2_ = cur_bp;
#line 87 "src/marker.vala"
		_tmp3_ = _tmp2_->mark;
#line 87 "src/marker.vala"
		_tmp4_ = marker_copy (_tmp3_);
#line 87 "src/marker.vala"
		mark_ring = g_list_append (mark_ring, _tmp4_);
#line 891 "marker.c"
	} else {
		Marker* m = NULL;
		Marker* _tmp5_;
		Marker* _tmp6_;
		Buffer* _tmp7_;
		Marker* _tmp8_;
		Marker* _tmp9_;
#line 89 "src/marker.vala"
		_tmp5_ = marker_new ();
#line 89 "src/marker.vala"
		m = _tmp5_;
#line 90 "src/marker.vala"
		_tmp6_ = m;
#line 90 "src/marker.vala"
		_tmp7_ = cur_bp;
#line 90 "src/marker.vala"
		marker_move (_tmp6_, _tmp7_, (gsize) 0);
#line 91 "src/marker.vala"
		_tmp8_ = m;
#line 91 "src/marker.vala"
		_tmp9_ = _marker_ref0 (_tmp8_);
#line 91 "src/marker.vala"
		mark_ring = g_list_append (mark_ring, _tmp9_);
#line 86 "src/marker.vala"
		_marker_unref0 (m);
#line 917 "marker.c"
	}
#line 94 "src/marker.vala"
	funcall ("set-mark", NULL, NULL);
#line 921 "marker.c"
}

void
pop_mark (void)
{
	Marker* m = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	gconstpointer _tmp2_;
	Marker* _tmp3_;
	Marker* _tmp4_;
	Marker* _tmp5_;
	Buffer* _tmp6_;
	Marker* buf_m = NULL;
	Marker* _tmp7_;
	Buffer* _tmp8_;
	Marker* _tmp9_;
	Marker* _tmp10_;
	Marker* _tmp11_;
	Marker* _tmp13_;
	Buffer* _tmp14_;
	Marker* _tmp15_;
	Marker* _tmp16_;
	Marker* _tmp17_;
	Marker* _tmp18_;
#line 99 "src/marker.vala"
	_tmp0_ = mark_ring;
#line 99 "src/marker.vala"
	_tmp1_ = mark_ring;
#line 99 "src/marker.vala"
	_tmp2_ = g_list_nth_data (_tmp0_, g_list_length (_tmp1_) - 1);
#line 99 "src/marker.vala"
	_tmp3_ = _marker_ref0 ((Marker*) _tmp2_);
#line 99 "src/marker.vala"
	m = _tmp3_;
#line 100 "src/marker.vala"
	_tmp4_ = m;
#line 100 "src/marker.vala"
	_vala_assert (_tmp4_ != NULL, "m != null");
#line 103 "src/marker.vala"
	_tmp5_ = m;
#line 103 "src/marker.vala"
	_tmp6_ = _tmp5_->bp;
#line 103 "src/marker.vala"
	_vala_assert (_tmp6_ != NULL, "m.bp != null");
#line 104 "src/marker.vala"
	_tmp7_ = m;
#line 104 "src/marker.vala"
	_tmp8_ = _tmp7_->bp;
#line 104 "src/marker.vala"
	_tmp9_ = _tmp8_->mark;
#line 104 "src/marker.vala"
	_tmp10_ = _marker_ref0 (_tmp9_);
#line 104 "src/marker.vala"
	buf_m = _tmp10_;
#line 105 "src/marker.vala"
	_tmp11_ = buf_m;
#line 105 "src/marker.vala"
	if (_tmp11_ != NULL) {
#line 981 "marker.c"
		Marker* _tmp12_;
#line 106 "src/marker.vala"
		_tmp12_ = buf_m;
#line 106 "src/marker.vala"
		marker_unchain (_tmp12_);
#line 987 "marker.c"
	}
#line 108 "src/marker.vala"
	_tmp13_ = m;
#line 108 "src/marker.vala"
	_tmp14_ = _tmp13_->bp;
#line 108 "src/marker.vala"
	_tmp15_ = m;
#line 108 "src/marker.vala"
	_tmp16_ = marker_copy (_tmp15_);
#line 108 "src/marker.vala"
	_marker_unref0 (_tmp14_->mark);
#line 108 "src/marker.vala"
	_tmp14_->mark = _tmp16_;
#line 110 "src/marker.vala"
	_tmp17_ = m;
#line 110 "src/marker.vala"
	marker_unchain (_tmp17_);
#line 111 "src/marker.vala"
	_tmp18_ = m;
#line 111 "src/marker.vala"
	mark_ring = g_list_remove (mark_ring, _tmp18_);
#line 98 "src/marker.vala"
	_marker_unref0 (buf_m);
#line 98 "src/marker.vala"
	_marker_unref0 (m);
#line 1013 "marker.c"
}

void
set_mark (void)
{
	Buffer* _tmp0_;
	Marker* _tmp1_;
#line 116 "src/marker.vala"
	_tmp0_ = cur_bp;
#line 116 "src/marker.vala"
	_tmp1_ = _tmp0_->mark;
#line 116 "src/marker.vala"
	if (_tmp1_ == NULL) {
#line 1027 "marker.c"
		Buffer* _tmp2_;
		Marker* _tmp3_;
#line 117 "src/marker.vala"
		_tmp2_ = cur_bp;
#line 117 "src/marker.vala"
		_tmp3_ = marker_point ();
#line 117 "src/marker.vala"
		_marker_unref0 (_tmp2_->mark);
#line 117 "src/marker.vala"
		_tmp2_->mark = _tmp3_;
#line 1038 "marker.c"
	} else {
		Buffer* _tmp4_;
		Marker* _tmp5_;
		Buffer* _tmp6_;
		Buffer* _tmp7_;
		gsize _tmp8_;
		gsize _tmp9_;
#line 119 "src/marker.vala"
		_tmp4_ = cur_bp;
#line 119 "src/marker.vala"
		_tmp5_ = _tmp4_->mark;
#line 119 "src/marker.vala"
		_tmp6_ = cur_bp;
#line 119 "src/marker.vala"
		_tmp7_ = cur_bp;
#line 119 "src/marker.vala"
		_tmp8_ = buffer_get_pt (_tmp7_);
#line 119 "src/marker.vala"
		_tmp9_ = _tmp8_;
#line 119 "src/marker.vala"
		marker_move (_tmp5_, _tmp6_, _tmp9_);
#line 1060 "marker.c"
	}
}

